<?php
namespace Ak\Test\Constraint\Container;

use PHPUnit\Framework\Constraint\Constraint;
use Psr\Container\ContainerInterface;

/**
 * Utvrđuje da container sadrži servis s datim imenom.
 *
 * @package Ak\Test\Constraint\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/test
 */
class ServiceExists extends Constraint
{
    private array $names;
    private string $lastName;

    /**
     * Konstruktor.
     *
     * @param array|string $names
     */
    public function __construct($names)
    {
        $this->names = !is_array($names) ? [$names] : $names;
    }

    /**
     * @param ContainerInterface $other
     * @return bool
     */
    public function matches($other): bool
    {
        foreach ($this->names as $name) {
            $this->lastName = $name;
            if (!$other->has($name)) {
                return false;
            }
        }

        return true;
    }

    /**
     * @param mixed $other
     * @return string
     */
    protected function failureDescription($other): string
    {
        return 'the given container ' . $this->toString();
    }

    /**
     * Returns a string representation of the object.
     */
    public function toString(): string
    {
        return 'has the service named "' . $this->lastName . '"';
    }
}
